From 7779308fb6f477b486c353e20ed5067ac31fa71f Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Sun, 19 May 2019 13:31:00 +0200
Subject: [PATCH] templates: simplify {% extends %} paths as it is now possible
 with 1.11 (#33236)

---
 debian/control                                                  | 2 +-
 templates/variants/alpes-maritimes-2018/authentic2/login.html   | 2 +-
 templates/variants/alpes-maritimes-2018/theme.html              | 2 +-
 templates/variants/amiens-metropole/theme.html                  | 2 +-
 templates/variants/blois-2018/combo/page_template.html          | 2 +-
 templates/variants/bouches-du-rhone/authentic2/accounts.html    | 2 +-
 templates/variants/bouches-du-rhone/theme.html                  | 2 +-
 templates/variants/entrouvert/combo/page_template.html          | 2 +-
 templates/variants/fontenay-sous-bois-2018/theme.html           | 2 +-
 templates/variants/grandlyon-gnm/combo/page_template.html       | 2 +-
 templates/variants/grandlyon-gnm/theme.html                     | 2 +-
 templates/variants/grandlyon/theme.html                         | 2 +-
 templates/variants/grenoble-metropole-2019/authentic2/base.html | 2 +-
 .../grenoble-metropole-2019/registration/registration_form.html | 2 +-
 templates/variants/grenoble-metropole/authentic2/base.html      | 2 +-
 .../grenoble-metropole/registration/registration_form.html      | 2 +-
 templates/variants/haute-garonne-cd31/authentic2/accounts.html  | 2 +-
 templates/variants/haute-garonne-cd31/combo/page_template.html  | 2 +-
 .../variants/hautes-alpes-2018/combo/page_template_neutre.html  | 2 +-
 templates/variants/lille/authentic2/accounts.html               | 2 +-
 templates/variants/lille/combo/page_template.html               | 2 +-
 templates/variants/mauguio/theme.html                           | 2 +-
 templates/variants/metz-metropole/theme.html                    | 2 +-
 templates/variants/montpellier/authentic2/accounts.html         | 2 +-
 templates/variants/moselle/combo/page_template.html             | 2 +-
 .../variants/nanterre/authentic2/password_change_body.html      | 2 +-
 templates/variants/nanterre/authentic2/password_change_body.txt | 2 +-
 templates/variants/orleans/theme.html                           | 2 +-
 templates/variants/pre-saint-gervais/authentic2/login.html      | 2 +-
 templates/variants/pre-saint-gervais/combo/page_template.html   | 2 +-
 templates/variants/pre-saint-gervais/theme.html                 | 2 +-
 templates/variants/quimper/authentic2/accounts.html             | 2 +-
 templates/variants/quimper/authentic2/login.html                | 2 +-
 templates/variants/rochefort/theme.html                         | 2 +-
 templates/variants/strasbourg-2018/authentic2/login.html        | 2 +-
 .../strasbourg-2018/authentic2/password_change_body.html        | 2 +-
 .../strasbourg-2018/authentic2/password_change_body.txt         | 2 +-
 templates/variants/toodego/combo/page_template.html             | 2 +-
 templates/variants/toodego/theme.html                           | 2 +-
 templates/variants/toulouse/authentic2/accounts.html            | 2 +-
 templates/variants/toulouse/authentic2/login.html               | 2 +-
 templates/variants/toulouse/registration/registration_form.html | 2 +-
 templates/variants/toulouse/theme.html                          | 2 +-
 templates/variants/venissieux/theme.html                        | 2 +-
 templates/variants/villeurbanne-2018/authentic2/base.html       | 2 +-
 templates/variants/villeurbanne-2018/combo/page_template.html   | 2 +-
 templates/variants/vincennes-2018/theme.html                    | 2 +-
 47 files changed, 47 insertions(+), 47 deletions(-)

diff --git a/debian/control b/debian/control
index 5f392e25..9fc3f95c 100644
--- a/debian/control
+++ b/debian/control
@@ -9,6 +9,6 @@ Homepage: http://git.entrouvert.org/publik-base-theme.git
 Package: publik-base-theme
 Architecture: all
 Depends: ${shlibs:Depends}, ${misc:Depends}, python-gadjo, python-xstatic-abrilfatface
-Conflicts: python-authentic2 (< 2.1.20.742.gb6ee096-0)
+Conflicts: python-authentic2 (< 2.1.20.742.gb6ee096-0), python-django (<= 1:1.11)
 Breaks: combo (< 0.7.1)
 Description: Publik Base Theme
diff --git a/templates/variants/alpes-maritimes-2018/authentic2/login.html b/templates/variants/alpes-maritimes-2018/authentic2/login.html
index 207c189c..fac000e2 100644
--- a/templates/variants/alpes-maritimes-2018/authentic2/login.html
+++ b/templates/variants/alpes-maritimes-2018/authentic2/login.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/login.html" %}
+{% extends "authentic2/login.html" %}
 
 {% block login-pre %}
 <div class="cell">
diff --git a/templates/variants/alpes-maritimes-2018/theme.html b/templates/variants/alpes-maritimes-2018/theme.html
index b4efdfb1..ed6c4f63 100644
--- a/templates/variants/alpes-maritimes-2018/theme.html
+++ b/templates/variants/alpes-maritimes-2018/theme.html
@@ -1,4 +1,4 @@
-{% extends '../../theme.html' %}
+{% extends 'theme.html' %}
 
 {% block header-post %}
 <div class="departement">
diff --git a/templates/variants/amiens-metropole/theme.html b/templates/variants/amiens-metropole/theme.html
index ba84afa8..9611ad9b 100644
--- a/templates/variants/amiens-metropole/theme.html
+++ b/templates/variants/amiens-metropole/theme.html
@@ -1,4 +1,4 @@
-{% extends '../../theme.html' %}
+{% extends 'theme.html' %}
 {% load static i18n combo gadjo %}
 
 {% block extra_top_head %}
diff --git a/templates/variants/blois-2018/combo/page_template.html b/templates/variants/blois-2018/combo/page_template.html
index 013ad721..9d4fcb3b 100644
--- a/templates/variants/blois-2018/combo/page_template.html
+++ b/templates/variants/blois-2018/combo/page_template.html
@@ -1,4 +1,4 @@
-{% extends "../../combo/page_template.html" %}
+{% extends "combo/page_template.html" %}
 {% load combo %}
 
 {% block header-title %}
diff --git a/templates/variants/bouches-du-rhone/authentic2/accounts.html b/templates/variants/bouches-du-rhone/authentic2/accounts.html
index ab1e5e79..6e62b4f1 100644
--- a/templates/variants/bouches-du-rhone/authentic2/accounts.html
+++ b/templates/variants/bouches-du-rhone/authentic2/accounts.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/accounts.html" %}
+{% extends "authentic2/accounts.html" %}
 
 {% block account-management-bottom-actions %}
 <li><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
diff --git a/templates/variants/bouches-du-rhone/theme.html b/templates/variants/bouches-du-rhone/theme.html
index 1dd7b182..9fd4ecd9 100644
--- a/templates/variants/bouches-du-rhone/theme.html
+++ b/templates/variants/bouches-du-rhone/theme.html
@@ -1,4 +1,4 @@
-{% extends "../../theme.html" %}
+{% extends "theme.html" %}
 {% load static %}
 
 {% block header-pre %}
diff --git a/templates/variants/entrouvert/combo/page_template.html b/templates/variants/entrouvert/combo/page_template.html
index f216d890..82f84593 100644
--- a/templates/variants/entrouvert/combo/page_template.html
+++ b/templates/variants/entrouvert/combo/page_template.html
@@ -1,4 +1,4 @@
-{% extends '../../combo/page_template.html' %}
+{% extends 'combo/page_template.html' %}
 
 {% block user-info %}
 <div id="le">
diff --git a/templates/variants/fontenay-sous-bois-2018/theme.html b/templates/variants/fontenay-sous-bois-2018/theme.html
index b3d7a854..ab53fb21 100644
--- a/templates/variants/fontenay-sous-bois-2018/theme.html
+++ b/templates/variants/fontenay-sous-bois-2018/theme.html
@@ -1,4 +1,4 @@
-{% extends "../../theme.html" %}
+{% extends "theme.html" %}
 {% load static %}
 
 {% block header-pre %}
diff --git a/templates/variants/grandlyon-gnm/combo/page_template.html b/templates/variants/grandlyon-gnm/combo/page_template.html
index 216e08cd..399964f8 100644
--- a/templates/variants/grandlyon-gnm/combo/page_template.html
+++ b/templates/variants/grandlyon-gnm/combo/page_template.html
@@ -1,4 +1,4 @@
-{% extends "../../combo/page_template.html" %}
+{% extends "combo/page_template.html" %}
 {% load combo %}
 
 {% block menu %}
diff --git a/templates/variants/grandlyon-gnm/theme.html b/templates/variants/grandlyon-gnm/theme.html
index c51696dd..cd3956e1 100644
--- a/templates/variants/grandlyon-gnm/theme.html
+++ b/templates/variants/grandlyon-gnm/theme.html
@@ -1,4 +1,4 @@
-{% extends "../../theme.html" %}
+{% extends "theme.html" %}
 {% load static gnm %}
 
 {% block extra_top_head %}
diff --git a/templates/variants/grandlyon/theme.html b/templates/variants/grandlyon/theme.html
index 196fdb1e..9e5e3345 100644
--- a/templates/variants/grandlyon/theme.html
+++ b/templates/variants/grandlyon/theme.html
@@ -1,4 +1,4 @@
-{% extends "../../theme.html" %}
+{% extends "theme.html" %}
 {% load static assets combo %}
 
 {% block bodyargs %}{% get_asset "header:background" as header_background %}class="{% if header_background %}has-header-background{% endif %} {% block bodyclasses %}{% endblock %}" {% block bodyattrs %}{% endblock %}{% endblock %}
diff --git a/templates/variants/grenoble-metropole-2019/authentic2/base.html b/templates/variants/grenoble-metropole-2019/authentic2/base.html
index 4f381d86..5e12502d 100644
--- a/templates/variants/grenoble-metropole-2019/authentic2/base.html
+++ b/templates/variants/grenoble-metropole-2019/authentic2/base.html
@@ -1,4 +1,4 @@
-{% extends '../../authentic2/base.html' %}
+{% extends 'authentic2/base.html' %}
 
 {% block extra-top-head %}
   {% block extrascripts %}
diff --git a/templates/variants/grenoble-metropole-2019/registration/registration_form.html b/templates/variants/grenoble-metropole-2019/registration/registration_form.html
index f1c6dc3b..06c1dccc 100644
--- a/templates/variants/grenoble-metropole-2019/registration/registration_form.html
+++ b/templates/variants/grenoble-metropole-2019/registration/registration_form.html
@@ -1,4 +1,4 @@
-{% extends '../../registration/registration_form.html' %}
+{% extends 'registration/registration_form.html' %}
 
 {% block placeholder-content %}
 
diff --git a/templates/variants/grenoble-metropole/authentic2/base.html b/templates/variants/grenoble-metropole/authentic2/base.html
index 4f381d86..5e12502d 100644
--- a/templates/variants/grenoble-metropole/authentic2/base.html
+++ b/templates/variants/grenoble-metropole/authentic2/base.html
@@ -1,4 +1,4 @@
-{% extends '../../authentic2/base.html' %}
+{% extends 'authentic2/base.html' %}
 
 {% block extra-top-head %}
   {% block extrascripts %}
diff --git a/templates/variants/grenoble-metropole/registration/registration_form.html b/templates/variants/grenoble-metropole/registration/registration_form.html
index f1c6dc3b..06c1dccc 100644
--- a/templates/variants/grenoble-metropole/registration/registration_form.html
+++ b/templates/variants/grenoble-metropole/registration/registration_form.html
@@ -1,4 +1,4 @@
-{% extends '../../registration/registration_form.html' %}
+{% extends 'registration/registration_form.html' %}
 
 {% block placeholder-content %}
 
diff --git a/templates/variants/haute-garonne-cd31/authentic2/accounts.html b/templates/variants/haute-garonne-cd31/authentic2/accounts.html
index ab1e5e79..6e62b4f1 100644
--- a/templates/variants/haute-garonne-cd31/authentic2/accounts.html
+++ b/templates/variants/haute-garonne-cd31/authentic2/accounts.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/accounts.html" %}
+{% extends "authentic2/accounts.html" %}
 
 {% block account-management-bottom-actions %}
 <li><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
diff --git a/templates/variants/haute-garonne-cd31/combo/page_template.html b/templates/variants/haute-garonne-cd31/combo/page_template.html
index 6d4c4bc6..9aae34e1 100644
--- a/templates/variants/haute-garonne-cd31/combo/page_template.html
+++ b/templates/variants/haute-garonne-cd31/combo/page_template.html
@@ -1,4 +1,4 @@
-{% extends "../../combo/page_template.html" %}
+{% extends "combo/page_template.html" %}
 {% load combo %}
 
 {% block user-info %}
diff --git a/templates/variants/hautes-alpes-2018/combo/page_template_neutre.html b/templates/variants/hautes-alpes-2018/combo/page_template_neutre.html
index e1868e4f..8a27b918 100644
--- a/templates/variants/hautes-alpes-2018/combo/page_template_neutre.html
+++ b/templates/variants/hautes-alpes-2018/combo/page_template_neutre.html
@@ -1,4 +1,4 @@
-{% extends "../../theme.html" %}
+{% extends "theme.html" %}
 
 {% load static i18n combo gadjo %}
 {% block extra_top_head %}
diff --git a/templates/variants/lille/authentic2/accounts.html b/templates/variants/lille/authentic2/accounts.html
index ab1e5e79..6e62b4f1 100644
--- a/templates/variants/lille/authentic2/accounts.html
+++ b/templates/variants/lille/authentic2/accounts.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/accounts.html" %}
+{% extends "authentic2/accounts.html" %}
 
 {% block account-management-bottom-actions %}
 <li><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
diff --git a/templates/variants/lille/combo/page_template.html b/templates/variants/lille/combo/page_template.html
index 90565c1b..dcde8dec 100644
--- a/templates/variants/lille/combo/page_template.html
+++ b/templates/variants/lille/combo/page_template.html
@@ -1,4 +1,4 @@
-{% extends "../../combo/page_template.html" %}
+{% extends "combo/page_template.html" %}
 {% load combo %}
 
 {% block header-title %}
diff --git a/templates/variants/mauguio/theme.html b/templates/variants/mauguio/theme.html
index 6edbb273..0adc4d4b 100644
--- a/templates/variants/mauguio/theme.html
+++ b/templates/variants/mauguio/theme.html
@@ -1,4 +1,4 @@
-{% extends '../../theme.html' %}
+{% extends 'theme.html' %}
 
 {% block header-pre %}
 <a id="site-ville" href="https://www.mauguio-carnon.com/">Maugio Carnon</a>
diff --git a/templates/variants/metz-metropole/theme.html b/templates/variants/metz-metropole/theme.html
index 3f973ddd..267c72c8 100644
--- a/templates/variants/metz-metropole/theme.html
+++ b/templates/variants/metz-metropole/theme.html
@@ -1,4 +1,4 @@
-{% extends "../../theme.html" %}
+{% extends "theme.html" %}
 {% load static assets %}
 
 {% block header-title %}
diff --git a/templates/variants/montpellier/authentic2/accounts.html b/templates/variants/montpellier/authentic2/accounts.html
index e92061e6..72ec8587 100644
--- a/templates/variants/montpellier/authentic2/accounts.html
+++ b/templates/variants/montpellier/authentic2/accounts.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/accounts.html" %}
+{% extends "authentic2/accounts.html" %}
 {% load i18n staticfiles %}
 
 {% block extra-body-class %}authentic-page{% endblock %}
diff --git a/templates/variants/moselle/combo/page_template.html b/templates/variants/moselle/combo/page_template.html
index efc6eb2d..00105c74 100644
--- a/templates/variants/moselle/combo/page_template.html
+++ b/templates/variants/moselle/combo/page_template.html
@@ -1,4 +1,4 @@
-{% extends "../../combo/page_template.html" %}
+{% extends "combo/page_template.html" %}
 {% load combo %}
 
 {% block nav %}
diff --git a/templates/variants/nanterre/authentic2/password_change_body.html b/templates/variants/nanterre/authentic2/password_change_body.html
index b5f3d6ee..4c441da4 100644
--- a/templates/variants/nanterre/authentic2/password_change_body.html
+++ b/templates/variants/nanterre/authentic2/password_change_body.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/password_change_body.html" %}
+{% extends "authentic2/password_change_body.html" %}
 
 {% block warn_if_not_requested %}
 <p>
diff --git a/templates/variants/nanterre/authentic2/password_change_body.txt b/templates/variants/nanterre/authentic2/password_change_body.txt
index 1be31090..d9215502 100644
--- a/templates/variants/nanterre/authentic2/password_change_body.txt
+++ b/templates/variants/nanterre/authentic2/password_change_body.txt
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/password_change_body.txt" %}
+{% extends "authentic2/password_change_body.txt" %}
 
 {% block warn_if_not_requested %}
 Si vous n'êtes pas à l'origine de cette demande, contactez-nous imédiatement
diff --git a/templates/variants/orleans/theme.html b/templates/variants/orleans/theme.html
index 8b099aed..869487ac 100644
--- a/templates/variants/orleans/theme.html
+++ b/templates/variants/orleans/theme.html
@@ -1,4 +1,4 @@
-{% extends '../../theme.html' %}
+{% extends 'theme.html' %}
 {% block header-top %}
 {% if metropole_url %}
 <div class="metropole-link"><a href="{{ metropole_url }}">Orléans-Métropole.fr</a></div>
diff --git a/templates/variants/pre-saint-gervais/authentic2/login.html b/templates/variants/pre-saint-gervais/authentic2/login.html
index 8092c4ff..f8140c5e 100644
--- a/templates/variants/pre-saint-gervais/authentic2/login.html
+++ b/templates/variants/pre-saint-gervais/authentic2/login.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/login.html" %}
+{% extends "authentic2/login.html" %}
 
 {% block login-pre %}
 <div id="login-pre">
diff --git a/templates/variants/pre-saint-gervais/combo/page_template.html b/templates/variants/pre-saint-gervais/combo/page_template.html
index 8824dffc..6ea0ea2b 100644
--- a/templates/variants/pre-saint-gervais/combo/page_template.html
+++ b/templates/variants/pre-saint-gervais/combo/page_template.html
@@ -1,4 +1,4 @@
-{% extends "../../combo/page_template.html" %}
+{% extends "combo/page_template.html" %}
 {% load combo %}
 
 {% block psg-mon-espace %}
diff --git a/templates/variants/pre-saint-gervais/theme.html b/templates/variants/pre-saint-gervais/theme.html
index 1688abf7..c596ad8d 100644
--- a/templates/variants/pre-saint-gervais/theme.html
+++ b/templates/variants/pre-saint-gervais/theme.html
@@ -1,4 +1,4 @@
-{% extends "../../theme.html" %}
+{% extends "theme.html" %}
 {% load static %}
 
 {% block header-top %}
diff --git a/templates/variants/quimper/authentic2/accounts.html b/templates/variants/quimper/authentic2/accounts.html
index ab1e5e79..6e62b4f1 100644
--- a/templates/variants/quimper/authentic2/accounts.html
+++ b/templates/variants/quimper/authentic2/accounts.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/accounts.html" %}
+{% extends "authentic2/accounts.html" %}
 
 {% block account-management-bottom-actions %}
 <li><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
diff --git a/templates/variants/quimper/authentic2/login.html b/templates/variants/quimper/authentic2/login.html
index 4aeeeb62..a4fb10c4 100644
--- a/templates/variants/quimper/authentic2/login.html
+++ b/templates/variants/quimper/authentic2/login.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/login.html" %}
+{% extends "authentic2/login.html" %}
 
 {% block login-pre %}
 <h1 id="login-title">Se connecter<br> <span>avec mes identifiants Quimper+</span></h1>
diff --git a/templates/variants/rochefort/theme.html b/templates/variants/rochefort/theme.html
index ddab4390..788097a5 100644
--- a/templates/variants/rochefort/theme.html
+++ b/templates/variants/rochefort/theme.html
@@ -1,4 +1,4 @@
-{% extends '../../theme.html' %}
+{% extends 'theme.html' %}
 
 {% block header-title %}
 {{ block.super }}
diff --git a/templates/variants/strasbourg-2018/authentic2/login.html b/templates/variants/strasbourg-2018/authentic2/login.html
index 269d7ce6..9aa6e00f 100644
--- a/templates/variants/strasbourg-2018/authentic2/login.html
+++ b/templates/variants/strasbourg-2018/authentic2/login.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/login.html" %}
+{% extends "authentic2/login.html" %}
 
 {% block login-bottom %}
 <div id="welcome-text">
diff --git a/templates/variants/strasbourg-2018/authentic2/password_change_body.html b/templates/variants/strasbourg-2018/authentic2/password_change_body.html
index c18666bb..64914682 100644
--- a/templates/variants/strasbourg-2018/authentic2/password_change_body.html
+++ b/templates/variants/strasbourg-2018/authentic2/password_change_body.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/password_change_body.html" %}
+{% extends "authentic2/password_change_body.html" %}
 
 {% block warn_if_not_requested %}
 <p>
diff --git a/templates/variants/strasbourg-2018/authentic2/password_change_body.txt b/templates/variants/strasbourg-2018/authentic2/password_change_body.txt
index 829a7d9c..8bcf7a51 100644
--- a/templates/variants/strasbourg-2018/authentic2/password_change_body.txt
+++ b/templates/variants/strasbourg-2018/authentic2/password_change_body.txt
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/password_change_body.txt" %}
+{% extends "authentic2/password_change_body.txt" %}
 
 {% block warn_if_not_requested %}
 Si vous n'aviez pas demandé le changement de votre mot de passe, vous pouvez
diff --git a/templates/variants/toodego/combo/page_template.html b/templates/variants/toodego/combo/page_template.html
index 3facfa47..c4baf924 100644
--- a/templates/variants/toodego/combo/page_template.html
+++ b/templates/variants/toodego/combo/page_template.html
@@ -1,4 +1,4 @@
-{% extends "../../combo/page_template.html" %}
+{% extends "combo/page_template.html" %}
 {% load combo %}
 
 {% block menu %}
diff --git a/templates/variants/toodego/theme.html b/templates/variants/toodego/theme.html
index 5defc0fe..2fbef325 100644
--- a/templates/variants/toodego/theme.html
+++ b/templates/variants/toodego/theme.html
@@ -1,4 +1,4 @@
-{% extends "../../theme.html" %}
+{% extends "theme.html" %}
 {% load static gnm assets combo %}
 
 {% block extra_top_head %}
diff --git a/templates/variants/toulouse/authentic2/accounts.html b/templates/variants/toulouse/authentic2/accounts.html
index 97233be1..fcbea82d 100644
--- a/templates/variants/toulouse/authentic2/accounts.html
+++ b/templates/variants/toulouse/authentic2/accounts.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/accounts.html" %}
+{% extends "authentic2/accounts.html" %}
 
 {% block content %}
 <div id="title-section">
diff --git a/templates/variants/toulouse/authentic2/login.html b/templates/variants/toulouse/authentic2/login.html
index 30d1dcc5..ba24cf04 100644
--- a/templates/variants/toulouse/authentic2/login.html
+++ b/templates/variants/toulouse/authentic2/login.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/login.html" %}
+{% extends "authentic2/login.html" %}
 
 {% block login-pre %}
 <div class="a2-block" id="registration-title"><h2>Se connecter</h2>
diff --git a/templates/variants/toulouse/registration/registration_form.html b/templates/variants/toulouse/registration/registration_form.html
index 2ef5a545..d580b6a1 100644
--- a/templates/variants/toulouse/registration/registration_form.html
+++ b/templates/variants/toulouse/registration/registration_form.html
@@ -1,4 +1,4 @@
-{% extends '../../registration/registration_form.html' %}
+{% extends 'registration/registration_form.html' %}
 {% load i18n %}
 
 {% block registration-pre %}
diff --git a/templates/variants/toulouse/theme.html b/templates/variants/toulouse/theme.html
index 742bae3d..2d329585 100644
--- a/templates/variants/toulouse/theme.html
+++ b/templates/variants/toulouse/theme.html
@@ -1,4 +1,4 @@
-{% extends "../../theme.html" %}
+{% extends "theme.html" %}
 
 {% block content-pre %}
 <div id="actu">
diff --git a/templates/variants/venissieux/theme.html b/templates/variants/venissieux/theme.html
index 35b9fda3..1a4c752d 100644
--- a/templates/variants/venissieux/theme.html
+++ b/templates/variants/venissieux/theme.html
@@ -1,4 +1,4 @@
-{% extends "../../theme.html" %}
+{% extends "theme.html" %}
 {% load static %}
 
 {% block header-pre %}
diff --git a/templates/variants/villeurbanne-2018/authentic2/base.html b/templates/variants/villeurbanne-2018/authentic2/base.html
index a503de7d..389cb66f 100644
--- a/templates/variants/villeurbanne-2018/authentic2/base.html
+++ b/templates/variants/villeurbanne-2018/authentic2/base.html
@@ -1,4 +1,4 @@
-{% extends "../../authentic2/base.html" %}
+{% extends "authentic2/base.html" %}
 
 {% block user-info %}
    {% include "user_info.html" %}
diff --git a/templates/variants/villeurbanne-2018/combo/page_template.html b/templates/variants/villeurbanne-2018/combo/page_template.html
index 0669d995..24222c63 100644
--- a/templates/variants/villeurbanne-2018/combo/page_template.html
+++ b/templates/variants/villeurbanne-2018/combo/page_template.html
@@ -1,4 +1,4 @@
-{% extends '../../combo/page_template.html' %}
+{% extends 'combo/page_template.html' %}
 {% load combo %}
 
 {% block user-info %}
diff --git a/templates/variants/vincennes-2018/theme.html b/templates/variants/vincennes-2018/theme.html
index 5125d8f9..e2142f75 100644
--- a/templates/variants/vincennes-2018/theme.html
+++ b/templates/variants/vincennes-2018/theme.html
@@ -1,4 +1,4 @@
-{% extends '../../theme.html' %}
+{% extends 'theme.html' %}
 
 {% block header-top %}
 <a id="vincennes-fr" href="https://www.vincennes.fr/">vincennes.fr</a>
-- 
2.20.1