From 928584790c029a125d052fad8b66d6ad06925b0b Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Sun, 19 May 2019 14:18:30 +0200
Subject: [PATCH 1/2] misc: require django 1.11 (#33238)

---
 Jenkinsfile      | 20 +++++---------------
 debian/control   |  3 ++-
 requirements.txt |  2 +-
 setup.py         |  2 +-
 tox.ini          |  8 ++------
 5 files changed, 11 insertions(+), 24 deletions(-)

diff --git a/Jenkinsfile b/Jenkinsfile
index 950f397..7fe5799 100644
--- a/Jenkinsfile
+++ b/Jenkinsfile
@@ -14,25 +14,15 @@ pipeline {
                         utils = new Utils()
                         utils.publish_coverage('coverage-*.xml')
                         utils.publish_coverage_native(
-                            'index.html', 'htmlcov-coverage-django18-authentic', 'Coverage authentic tests')
+                            'index.html', 'htmlcov-coverage-authentic', 'Coverage authentic tests')
                         utils.publish_coverage_native(
-                            'index.html', 'htmlcov-coverage-django18-hobo', 'Coverage hobo tests')
+                            'index.html', 'htmlcov-coverage-hobo', 'Coverage hobo tests')
                         utils.publish_coverage_native(
-                            'index.html', 'htmlcov-coverage-django18-authentic', 'Coverage multipublik tests')
+                            'index.html', 'htmlcov-coverage-multipublik', 'Coverage multipublik tests')
                         utils.publish_coverage_native(
-                            'index.html', 'htmlcov-coverage-django18-authentic', 'Coverage multitenant tests')
+                            'index.html', 'htmlcov-coverage-multitenant', 'Coverage multitenant tests')
                         utils.publish_coverage_native(
-                            'index.html', 'htmlcov-coverage-django18-authentic', 'Coverage passerelle tests')
-                        utils.publish_coverage_native(
-                            'index.html', 'htmlcov-coverage-django111-authentic', 'Coverage authentic tests')
-                        utils.publish_coverage_native(
-                            'index.html', 'htmlcov-coverage-django111-hobo', 'Coverage hobo tests')
-                        utils.publish_coverage_native(
-                            'index.html', 'htmlcov-coverage-django111-authentic', 'Coverage multipublik tests')
-                        utils.publish_coverage_native(
-                            'index.html', 'htmlcov-coverage-django111-authentic', 'Coverage multitenant tests')
-                        utils.publish_coverage_native(
-                            'index.html', 'htmlcov-coverage-django111-authentic', 'Coverage passerelle tests')
+                            'index.html', 'htmlcov-coverage-passerelle', 'Coverage passerelle tests')
                         utils.publish_pylint('pylint.out')
                     }
                     junit 'junit-*.xml'
diff --git a/debian/control b/debian/control
index b14dd38..c10a6bc 100644
--- a/debian/control
+++ b/debian/control
@@ -10,6 +10,7 @@ Package: python-hobo
 Architecture: all
 Depends: ${misc:Depends},
     ${python:Depends},
+    python-django (>= 1:1.11),
     python-celery (>= 3.1.13),
     python-requests,
     python-raven,
@@ -19,7 +20,7 @@ Depends: ${misc:Depends},
     python-prometheus-client,
     python-djangorestframework,
     python-dnspython
-Recommends: python-django (>= 1.8),
+Recommends:
     python-gadjo,
     python-django-mellon (>= 1.2.22.26),
     memcached,
diff --git a/requirements.txt b/requirements.txt
index 0c273f8..5a81e60 100644
--- a/requirements.txt
+++ b/requirements.txt
@@ -1,4 +1,4 @@
-django>=1.8,<1.9
+django>=1.11,<1.12
 -e git+http://repos.entrouvert.org/gadjo.git/#egg=gadjo
 celery<4
 django-mellon
diff --git a/setup.py b/setup.py
index 49980d0..6a849b3 100644
--- a/setup.py
+++ b/setup.py
@@ -104,7 +104,7 @@ setup(
         'Programming Language :: Python',
         'Programming Language :: Python :: 2',
     ],
-    install_requires=['django>=1.8, <1.12',
+    install_requires=['django>=1.11, <1.12',
         'gadjo',
         'celery<4',
         'django-mellon',
diff --git a/tox.ini b/tox.ini
index eae6a97..9c981a4 100644
--- a/tox.ini
+++ b/tox.ini
@@ -4,7 +4,7 @@
 # and then run "tox" from this directory.
 [tox]
 toxworkdir = {env:TMPDIR:/tmp}/tox-{env:USER}/hobo
-envlist = coverage-{django18,django111}-{authentic,hobo,multipublik,multitenant,passerelle,schemas},
+envlist = coverage-{authentic,hobo,multipublik,multitenant,passerelle,schemas},
 
 [testenv]
 basepython = python2
@@ -30,8 +30,6 @@ setenv =
 	coverage: COVERAGE=--junitxml=junit-{envname}.xml --cov-report xml --cov-report html --cov=hobo/ --cov-config .coveragerc
 	fast: NOMIGRATIONS=--nomigrations
 deps:
-	django18: django>=1.8,<1.9
-	django111: django>=1.11,<1.12
 	pytest<4.1
 	pytest-cov
 	pytest-django
@@ -44,9 +42,7 @@ deps:
 	django-webtest<1.9.3
 	celery<4
 	Markdown<3
-	django18: django-tables2<1.1
-	django111: django-tables2<2.0
-	django18: django-jsonfield<1.1
+	django-tables2<2.0
 	authentic: http://git.entrouvert.org/authentic.git/snapshot/authentic-master.tar.gz
 	passerelle: http://git.entrouvert.org/passerelle.git/snapshot/passerelle-master.tar.gz
 	passerelle: suds
-- 
2.20.1